Subject: Re: bug#65286: 30.0.50; package-install-file for built-in package

From: Ihor Radchenko <[email-masked]>
Date: Mon, 14 Aug 2023 15:09:53 +0000

Philip Kaludercic <[email-masked]> writes:

> For the record, these are the changes between your checkout and what is
> on master:

The same error happens for a number of other libraries. I just did not
list all the errors in the initial report.

Also, the error does not happen when using Org main.
I started getting error after the following edits in across Org libraries:

> -(require 'ob-9.7 "ob")
> -(require 'org-macs-9.7 "org-macs")
> -(require 'ox-ascii-9.7 "ox-ascii")
> +(require 'org-macs)
> +(org-assert-version)
>   ...
>  (provide 'ob-gnuplot)
> -(provide 'ob-gnuplot-9.7)

> The (org-assert-version) seems new, with this check
>
>   `(unless (or org--inhibit-version-check (equal (org-release) ,(org-release)))
>      ...
>
> could evaluating (org-release) during macro-expansion cause this
> recursive load issue?

Nope. `org-release' is defined in automatically generated org-version.el
library, which does not depend on anything:

;;; org-version.el --- autogenerated file, do not edit  -*- lexical-binding: t -*-
;;
;;; Code:
;;;###autoload
(defun org-release ()
  "The release version of Org.
Inserted by installing Org mode or when a release is made."
   (let ((org-release "9.6.7"))
     org-release))
;;;###autoload
(defun org-git-version ()
  "The Git version of Org mode.
Inserted by installing Org or when a release is made."
   (let ((org-git-version "release_9.6.7-13-g99cc96"))
     org-git-version))

(provide 'org-version)

;; Local Variables:
;; version-control: never
;; no-byte-compile: t
;; coding: utf-8
;; End:
;;; org-version.el ends here

>> To be clear, I have no clue at all what is going on. I made some
>> relatively innocent changes in Org that added a couple of provide
>> statements. I could see things breaking completely, but not __only__
>> when built-in Org is loaded. So, any attempt to reduce the reproducer
>> steps will be me trying random things - not very productive unless you
>> absolutely cannot use the reproducer I provided.
>
> No, sorry I couldn't reproduce it on my system :/
>
> M-x emacs-version
> GNU Emacs 30.0.50 (build 5, x86_64-pc-linux-gnu, GTK+ Version 3.24.37, cairo version 1.16.0) of 2023-08-14

Curious.
To be sure, I just pulled the latest master, did autogen -> configure
(with no arguments) -> make bootstrap, and followed the steps to
reproduce. I can still see the same problem.

Same using Emacs 29, Emacs 28, and Emacs 27.

-- 
Ihor Radchenko // yantar92,
Org mode contributor,
Learn more about Org mode at <https://orgmode.org/>.
Support Org development at <https://liberapay.com/org-mode>,
or support my work at <https://liberapay.com/yantar92>